# phpDox - Source of QueryBuilder.php

# Source of file QueryBuilder.php

Size: 18,191 Bytes - Last Modified: 2020-04-23T17:55:58-04:00

## src/QueryBuilder.php

1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728 729 730 731 732 733 734 735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759 760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798 799 800 801 802 803 804 805 806 807 808 809 810 811 812 813 814 815 816 817 818 819 820 821

    <?php declare(strict_types=1);

    /**

     * Query

     *

     * SQL Query Builder / Database Abstraction Layer

     *

     * PHP version 7.4

     *

     * @package     Query

     * @author      Timothy J. Warren <tim@timshomepage.net>

     * @copyright   2012 - 2020 Timothy J. Warren

     * @license     http://www.opensource.org/licenses/mit-license.html  MIT License

     * @link        https://git.timshomepage.net/aviat/Query

     * @version     3.0.0

     */

    namespace Query;

    use function is_array;

    use function is_int;

    use function mb_trim;

    use PDOStatement;

    /**

     * Convenience class for creating sql queries

     */

    class QueryBuilder extends QueryBuilderBase implements QueryBuilderInterface {

    	// --------------------------------------------------------------------------

    	// ! Select Queries

    	// --------------------------------------------------------------------------

    	/**

    	 * Specifies rows to select in a query

    	 *

    	 * @param string $fields

    	 * @return self

    	 */

    	public function select(string $fields): self

    	{

    		// Split fields by comma

    		$fieldsArray = explode(',', $fields);

    		$fieldsArray = array_map('mb_trim', $fieldsArray);

    		// Split on 'As'

    		foreach ($fieldsArray as $key => $field)

    		{

    			if (stripos($field, 'as') !== FALSE)

    			{

    				$fieldsArray[$key] = preg_split('` as `i', $field);

    				$fieldsArray[$key] = array_map('mb_trim', $fieldsArray[$key]);

    			}

    		}

    		// Quote the identifiers

    		$safeArray = $this->driver->quoteIdent($fieldsArray);

    		unset($fieldsArray);

    		// Join the strings back together

    		foreach ($safeArray as $i => $iValue)

    		{

    			if (is_array($iValue))

    			{

    				$safeArray[$i] = implode(' AS ', $iValue);

    			}

    		}

    		$this->state->appendSelectString(implode(', ', $safeArray));

    		return $this;

    	}

    	/**

    	 * Selects the maximum value of a field from a query

    	 *

    	 * @param string $field

    	 * @param string|bool $as

    	 * @return self

    	 */

    	public function selectMax(string $field, $as=FALSE): self

    	{

    		// Create the select string

    		$this->state->appendSelectString(' MAX'.$this->_select($field, $as));

    		return $this;

    	}

    	/**

    	 * Selects the minimum value of a field from a query

    	 *

    	 * @param string $field

    	 * @param string|bool $as

    	 * @return self

    	 */

    	public function selectMin(string $field, $as=FALSE): self

    	{

    		// Create the select string

    		$this->state->appendSelectString(' MIN'.$this->_select($field, $as));

    		return $this;

    	}

    	/**

    	 * Selects the average value of a field from a query

    	 *

    	 * @param string $field

    	 * @param string|bool $as

    	 * @return self

    	 */

    	public function selectAvg(string $field, $as=FALSE): self

    	{

    		// Create the select string

    		$this->state->appendSelectString(' AVG'.$this->_select($field, $as));

    		return $this;

    	}

    	/**

    	 * Selects the sum of a field from a query

    	 *

    	 * @param string $field

    	 * @param string|bool $as

    	 * @return self

    	 */

    	public function selectSum(string $field, $as=FALSE): self

    	{

    		// Create the select string

    		$this->state->appendSelectString(' SUM'.$this->_select($field, $as));

    		return $this;

    	}

    	/**

    	 * Add a 'returning' clause to an insert,update, or delete query

    	 *

    	 * @param string $fields

    	 * @return $this

    	 */

    	public function returning(string $fields = ''): self

    	{

    		$this->returning = TRUE;

    		// Re-use the string select field for generating the returning type clause

    		if ($fields !== '')

    		{

    			return $this->select($fields);

    		}

    		return $this;

    	}

    	/**

    	 * Adds the 'distinct' keyword to a query

    	 *

    	 * @return self

    	 */

    	public function distinct(): self

    	{

    		// Prepend the keyword to the select string

    		$this->state->setSelectString(' DISTINCT' . $this->state->getSelectString());

    		return $this;

    	}

    	/**

    	 * Tell the database to give you the query plan instead of result set

    	 *

    	 * @return self

    	 */

    	public function explain(): self

    	{

    		$this->explain = TRUE;

    		return $this;

    	}

    	/**

    	 * Specify the database table to select from

    	 *

    	 * Alias of `from` method to better match CodeIgniter 4

    	 *

    	 * @param string $tableName

    	 * @return self

    	 */

    	public function table(string $tableName): self

    	{

    		return $this->from($tableName);

    	}

    	/**

    	 * Specify the database table to select from

    	 *

    	 * @param string $tableName

    	 * @return self

    	 */

    	public function from(string $tableName): self

    	{

    		// Split identifiers on spaces

    		$identArray = explode(' ', mb_trim($tableName));

    		$identArray = array_map('mb_trim', $identArray);

    		// Quote the identifiers

    		$identArray[0] = $this->driver->quoteTable($identArray[0]);

    		$identArray = $this->driver->quoteIdent($identArray);

    		// Paste it back together

    		$this->state->setFromString(implode(' ', $identArray));

    		return $this;

    	}

    	// --------------------------------------------------------------------------

    	// ! 'Like' methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Creates a Like clause in the sql statement

    	 *

    	 * @param string $field

    	 * @param mixed $val

    	 * @param string $pos

    	 * @return self

    	 */

    	public function like(string $field, $val, string $pos=LikeType::BOTH): self

    	{

    		return $this->_like($field, $val, $pos);

    	}

    	/**

    	 * Generates an OR Like clause

    	 *

    	 * @param string $field

    	 * @param mixed $val

    	 * @param string $pos

    	 * @return self

    	 */

    	public function orLike(string $field, $val, string $pos=LikeType::BOTH): self

    	{

    		return $this->_like($field, $val, $pos, 'LIKE', 'OR');

    	}

    	/**

    	 * Generates a NOT LIKE clause

    	 *

    	 * @param string $field

    	 * @param mixed $val

    	 * @param string $pos

    	 * @return self

    	 */

    	public function notLike(string $field, $val, string $pos=LikeType::BOTH): self

    	{

    		return $this->_like($field, $val, $pos, 'NOT LIKE');

    	}

    	/**

    	 * Generates a OR NOT LIKE clause

    	 *

    	 * @param string $field

    	 * @param mixed $val

    	 * @param string $pos

    	 * @return self

    	 */

    	public function orNotLike(string $field, $val, string $pos=LikeType::BOTH): self

    	{

    		return $this->_like($field, $val, $pos, 'NOT LIKE', 'OR');

    	}

    	// --------------------------------------------------------------------------

    	// ! Having methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Generates a 'Having' clause

    	 *

    	 * @param mixed $key

    	 * @param mixed $val

    	 * @return self

    	 */

    	public function having($key, $val=[]): self

    	{

    		return $this->_having($key, $val);

    	}

    	/**

    	 * Generates a 'Having' clause prefixed with 'OR'

    	 *

    	 * @param mixed $key

    	 * @param mixed $val

    	 * @return self

    	 */

    	public function orHaving($key, $val=[]): self

    	{

    		return $this->_having($key, $val, 'OR');

    	}

    	// --------------------------------------------------------------------------

    	// ! 'Where' methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Specify condition(s) in the where clause of a query

    	 * Note: this function works with key / value, or a

    	 * passed array with key / value pairs

    	 *

    	 * @param mixed $key

    	 * @param mixed $val

    	 * @param mixed $escape

    	 * @return self

    	 */

    	public function where($key, $val=[], $escape=NULL): self

    	{

    		return $this->_whereString($key, $val);

    	}

    	/**

    	 * Where clause prefixed with "OR"

    	 *

    	 * @param string $key

    	 * @param mixed $val

    	 * @return self

    	 */

    	public function orWhere($key, $val=[]): self

    	{

    		return $this->_whereString($key, $val, 'OR');

    	}

    	/**

    	 * Where clause with 'IN' statement

    	 *

    	 * @param mixed $field

    	 * @param mixed $val

    	 * @return self

    	 */

    	public function whereIn($field, $val=[]): self

    	{

    		return $this->_whereIn($field, $val);

    	}

    	/**

    	 * Where in statement prefixed with "or"

    	 *

    	 * @param string $field

    	 * @param mixed $val

    	 * @return self

    	 */

    	public function orWhereIn($field, $val=[]): self

    	{

    		return $this->_whereIn($field, $val, 'IN', 'OR');

    	}

    	/**

    	 * WHERE NOT IN (FOO) clause

    	 *

    	 * @param string $field

    	 * @param mixed $val

    	 * @return self

    	 */

    	public function whereNotIn($field, $val=[]): self

    	{

    		return $this->_whereIn($field, $val, 'NOT IN');

    	}

    	/**

    	 * OR WHERE NOT IN (FOO) clause

    	 *

    	 * @param string $field

    	 * @param mixed $val

    	 * @return self

    	 */

    	public function orWhereNotIn($field, $val=[]): self

    	{

    		return $this->_whereIn($field, $val, 'NOT IN', 'OR');

    	}

    	// --------------------------------------------------------------------------

    	// ! Other Query Modifier methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Sets values for inserts / updates / deletes

    	 *

    	 * @param mixed $key

    	 * @param mixed $val

    	 * @return self

    	 */

    	public function set($key, $val = NULL): self

    	{

    		if (is_scalar($key))

    		{

    			$pairs = [$key => $val];

    		}

    		else

    		{

    			$pairs = $key;

    		}

    		$keys = array_keys($pairs);

    		$values = array_values($pairs);

    		$this->state->appendSetArrayKeys($keys);

    		$this->state->appendValues($values);

    		// Use the keys of the array to make the insert/update string

    		// Escape the field names

    		$this->state->setSetArrayKeys(

    			array_map([$this->driver, '_quote'], $this->state->getSetArrayKeys())

    		);

    		// Generate the "set" string

    		$setString = implode('=?,', $this->state->getSetArrayKeys());

    		$setString .= '=?';

    		$this->state->setSetString($setString);

    		return $this;

    	}

    	/**

    	 * Creates a join phrase in a compiled query

    	 *

    	 * @param string $table

    	 * @param string $condition

    	 * @param string $type

    	 * @return self

    	 */

    	public function join(string $table, string $condition, string $type=''): self

    	{

    		// Prefix and quote table name

    		$tableArr = explode(' ', mb_trim($table));

    		$tableArr[0] = $this->driver->quoteTable($tableArr[0]);

    		$tableArr = $this->driver->quoteIdent($tableArr);

    		$table = implode(' ', $tableArr);

    		// Parse out the join condition

    		$parsedCondition = $this->parser->compileJoin($condition);

    		$condition = $table . ' ON ' . $parsedCondition;

    		$this->state->appendMap("\n" . strtoupper($type) . ' JOIN ', $condition, MapType::JOIN);

    		return $this;

    	}

    	/**

    	 * Group the results by the selected field(s)

    	 *

    	 * @param mixed $field

    	 * @return self

    	 */

    	public function groupBy($field): self

    	{

    		if ( ! is_scalar($field))

    		{

    			$newGroupArray = array_merge(

    				$this->state->getGroupArray(),

    				array_map([$this->driver, 'quoteIdent'], $field)

    			);

    			$this->state->setGroupArray($newGroupArray);

    		}

    		else

    		{

    			$this->state->appendGroupArray($this->driver->quoteIdent($field));

    		}

    		$this->state->setGroupString(' GROUP BY ' . implode(',', $this->state->getGroupArray()));

    		return $this;

    	}

    	/**

    	 * Order the results by the selected field(s)

    	 *

    	 * @param string $field

    	 * @param string $type

    	 * @return self

    	 */

    	public function orderBy(string $field, string $type=''): self

    	{

    		// When ordering by random, do an ascending order if the driver

    		// doesn't support random ordering

    		if (stripos($type, 'rand') !== FALSE)

    		{

    			$rand = $this->driver->getSql()->random();

    			$type = $rand ?? 'ASC';

    		}

    		// Set fields for later manipulation

    		$field = $this->driver->quoteIdent($field);

    		$this->state->setOrderArray($field, $type);

    		$orderClauses = [];

    		// Flatten key/val pairs into an array of space-separated pairs

    		foreach($this->state->getOrderArray() as $k => $v)

    		{

    			$orderClauses[] = $k . ' ' . strtoupper($v);

    		}

    		// Set the final string

    		$orderString =  ! isset($rand)

    			? "\nORDER BY ".implode(', ', $orderClauses)

    			: "\nORDER BY".$rand;

    		$this->state->setOrderString($orderString);

    		return $this;

    	}

    	/**

    	 * Set a limit on the current sql statement

    	 *

    	 * @param int $limit

    	 * @param int|null $offset

    	 * @return self

    	 */

    	public function limit(int $limit, ?int $offset=NULL): self

    	{

    		$this->state->setLimit($limit);

    		$this->state->setOffset($offset);

    		return $this;

    	}

    	// --------------------------------------------------------------------------

    	// ! Query Grouping Methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Adds a paren to the current query for query grouping

    	 *

    	 * @return self

    	 */

    	public function groupStart(): self

    	{

    		$conj = empty($this->state->getQueryMap()) ? ' WHERE ' : ' ';

    		$this->state->appendMap($conj, '(', MapType::GROUP_START);

    		return $this;

    	}

    	/**

    	 * Adds a paren to the current query for query grouping,

    	 * prefixed with 'NOT'

    	 *

    	 * @return self

    	 */

    	public function notGroupStart(): self

    	{

    		$conj = empty($this->state->getQueryMap()) ? ' WHERE ' : ' AND ';

    		$this->state->appendMap($conj, ' NOT (', MapType::GROUP_START);

    		return $this;

    	}

    	/**

    	 * Adds a paren to the current query for query grouping,

    	 * prefixed with 'OR'

    	 *

    	 * @return self

    	 */

    	public function orGroupStart(): self

    	{

    		$this->state->appendMap('', ' OR (', MapType::GROUP_START);

    		return $this;

    	}

    	/**

    	 * Adds a paren to the current query for query grouping,

    	 * prefixed with 'OR NOT'

    	 *

    	 * @return self

    	 */

    	public function orNotGroupStart(): self

    	{

    		$this->state->appendMap('', ' OR NOT (', MapType::GROUP_START);

    		return $this;

    	}

    	/**

    	 * Ends a query group

    	 *

    	 * @return self

    	 */

    	public function groupEnd(): self

    	{

    		$this->state->appendMap('', ')', MapType::GROUP_END);

    		return $this;

    	}

    	// --------------------------------------------------------------------------

    	// ! Query execution methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Select and retrieve all records from the current table, and/or

    	 * execute current compiled query

    	 *

    	 * @param string $table

    	 * @param int|null $limit

    	 * @param int|null $offset

    	 * @return PDOStatement

    	 */

    	public function get(string $table='', ?int $limit=NULL, ?int $offset=NULL): PDOStatement

    	{

    		// Set the table

    		if ( ! empty($table))

    		{

    			$this->from($table);

    		}

    		// Set the limit, if it exists

    		if (is_int($limit))

    		{

    			$this->limit($limit, $offset);

    		}

    		return $this->_run('get', $table);

    	}

    	/**

    	 * Convenience method for get() with a where clause

    	 *

    	 * @param string $table

    	 * @param mixed $where

    	 * @param int|null $limit

    	 * @param int|null $offset

    	 * @return PDOStatement

    	 */

    	public function getWhere(string $table, $where=[], ?int $limit=NULL, ?int $offset=NULL): PDOStatement

    	{

    		// Create the where clause

    		$this->where($where);

    		// Return the result

    		return $this->get($table, $limit, $offset);

    	}

    	/**

    	 * Retrieve the number of rows in the selected table

    	 *

    	 * @param string $table

    	 * @return int

    	 */

    	public function countAll(string $table): int

    	{

    		$sql = 'SELECT * FROM '.$this->driver->quoteTable($table);

    		$res = $this->driver->query($sql);

    		return (int) count($res->fetchAll());

    	}

    	/**

    	 * Retrieve the number of results for the generated query - used

    	 * in place of the get() method

    	 *

    	 * @param string $table

    	 * @param boolean $reset

    	 * @return int

    	 */

    	public function countAllResults(string $table='', bool $reset = TRUE): int

    	{

    		// Set the table

    		if ( ! empty($table))

    		{

    			$this->from($table);

    		}

    		$result = $this->_run(QueryType::SELECT, $table, NULL, NULL, $reset);

    		$rows = $result->fetchAll();

    		return (int) count($rows);

    	}

    	/**

    	 * Creates an insert clause, and executes it

    	 *

    	 * @param string $table

    	 * @param mixed $data

    	 * @return PDOStatement

    	 */

    	public function insert(string $table, $data=[]): PDOStatement

    	{

    		if ( ! empty($data))

    		{

    			$this->set($data);

    		}

    		return $this->_run(QueryType::INSERT, $table);

    	}

    	/**

    	 * Creates and executes a batch insertion query

    	 *

    	 * @param string $table

    	 * @param array $data

    	 * @return PDOStatement

    	 */

    	public function insertBatch(string $table, $data=[]): ?PDOStatement

    	{

    		// Get the generated values and sql string

    		[$sql, $data] = $this->driver->insertBatch($table, $data);

    		return $sql !== NULL

    			? $this->_run('', $table, $sql, $data)

    			: NULL;

    	}

    	/**

    	 * Creates an update clause, and executes it

    	 *

    	 * @param string $table

    	 * @param mixed $data

    	 * @return PDOStatement

    	 */

    	public function update(string $table, $data=[]): PDOStatement

    	{

    		if ( ! empty($data))

    		{

    			$this->set($data);

    		}

    		return $this->_run(QueryType::UPDATE, $table);

    	}

    	/**

    	 * Creates a batch update, and executes it.

    	 * Returns the number of affected rows

    	 *

    	 * @param string $table

    	 * @param array $data

    	 * @param string $where

    	 * @return int|null

    	 */

    	public function updateBatch(string $table, array $data, string $where): ?int

    	{

    		if (empty($table) || empty($data) || empty($where))

    		{

    			return NULL;

    		}

    		// Get the generated values and sql string

    		[$sql, $data, $affectedRows] = $this->driver->updateBatch($table, $data, $where);

    		$this->_run('', $table, $sql, $data);

    		return $affectedRows;

    	}

    	/**

    	 * Deletes data from a table

    	 *

    	 * @param string $table

    	 * @param mixed $where

    	 * @return PDOStatement

    	 */

    	public function delete(string $table, $where=''): PDOStatement

    	{

    		// Set the where clause

    		if ( ! empty($where))

    		{

    			$this->where($where);

    		}

    		return $this->_run(QueryType::DELETE, $table);

    	}

    	// --------------------------------------------------------------------------

    	// ! SQL Returning Methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Returns the generated 'select' sql query

    	 *

    	 * @param string $table

    	 * @param bool $reset

    	 * @return string

    	 */

    	public function getCompiledSelect(string $table='', bool $reset=TRUE): string

    	{

    		// Set the table

    		if ( ! empty($table))

    		{

    			$this->from($table);

    		}

    		return $this->_getCompile(QueryType::SELECT, $table, $reset);

    	}

    	/**

    	 * Returns the generated 'insert' sql query

    	 *

    	 * @param string $table

    	 * @param bool $reset

    	 * @return string

    	 */

    	public function getCompiledInsert(string $table, bool $reset=TRUE): string

    	{

    		return $this->_getCompile(QueryType::INSERT, $table, $reset);

    	}

    	/**

    	 * Returns the generated 'update' sql query

    	 *

    	 * @param string $table

    	 * @param bool $reset

    	 * @return string

    	 */

    	public function getCompiledUpdate(string $table='', bool $reset=TRUE): string

    	{

    		return $this->_getCompile(QueryType::UPDATE, $table, $reset);

    	}

    	/**

    	 * Returns the generated 'delete' sql query

    	 *

    	 * @param string $table

    	 * @param bool $reset

    	 * @return string

    	 */

    	public function getCompiledDelete(string $table='', bool $reset=TRUE): string

    	{

    		return $this->_getCompile(QueryType::DELETE, $table, $reset);

    	}

    }